#pragma once 

#include "mbed.h"
#include "Pipe.h"

class SerialPipe : public Serial
{
public:
    SerialPipe(PinName tx, PinName rx, int rxSize = 128, int txSize = 128, const char* name = NULL);
    virtual ~SerialPipe(void);
    // tx channel
    int writeable(void);
    int putc(int c); // blocking
    int put(const void* buffer, int length, bool blocking = false);
    // rx channel
    int readable(void);
    int getc(void); // blocking
    int get(void* buffer, int length, bool blocking = false);
protected:
    virtual int _getc();
    virtual int _putc(int c);
    void rxIrqBuf(void);
    void txIrqBuf(void);
    void txStart(void);
    Pipe<char> _pipeRx;
    Pipe<char> _pipeTx;
};

// -----------------------------------------------------------------------
#define WAIT      -1
#define NOT_FOUND  0

class SerialPipeEx : public SerialPipe
{
public:
    SerialPipeEx(PinName tx, PinName rx, int rxSize = 128, int txSize = 128, const char* name = NULL);
    int getLine(char* buffer, int length);
};
